## ros-indigo-darknet 2016.11.27

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(darknet)

#https://github.com/pjreddie/darknet/pull/6
include(cmake/CMakeLists.txt)

## CATKIN ###
find_package(catkin REQUIRED)

# set variable for darknet-extras.cmake
set(ADD_DARKNET_DEFINITIONS_COMPILE_FLAGS_STRING "")
foreach(DEF ${CUDA_NVCC_DEFINITIONS})
  set(ADD_DARKNET_DEFINITIONS_COMPILE_FLAGS_STRING "${ADD_DARKNET_DEFINITIONS_COMPILE_FLAGS_STRING} -D${DEF}")
endforeach()
foreach(DIR ${CUDA_INCLUDE_DIRS})
  set(ADD_DARKNET_DEFINITIONS_COMPILE_FLAGS_STRING "${ADD_DARKNET_DEFINITIONS_COMPILE_FLAGS_STRING} -I${DIR}")
endforeach()
foreach(DIR ${OpenCV_INCLUDE_DIRS})
  set(ADD_DARKNET_DEFINITIONS_COMPILE_FLAGS_STRING "${ADD_DARKNET_DEFINITIONS_COMPILE_FLAGS_STRING} -I${DIR}")
endforeach()
set(LIBRARIES_STRING "")
foreach(LIB ${LIBRARIES})
  set(ADD_DARKNET_DEFINITIONS_LIBRARIES_STRING "${ADD_DARKNET_DEFINITIONS_LIBRARIES_STRING} ${LIB}")
endforeach()

catkin_package(
  LIBRARIES dnl
  CFG_EXTRAS darknet-extras.cmake)

# download weights
function(download_weights network_name)
  if(NOT EXISTS ${PROJECT_SOURCE_DIR}/weights/${network_name}.weights)
    message(STATUS "DARKNET: Download weights ${network_name}")
    file(DOWNLOAD http://pjreddie.com/media/files/${network_name}.weights
      ${PROJECT_SOURCE_DIR}/weights/${network_name}.weights
      TIMEOUT 120)
  else()
    message(STATUS "DARKNET: Using caced weights ${PROJECT_SOURCE_DIR}/weights/${network_name}.weights")
  endif()
endfunction()

# download pre-trained weights
file(MAKE_DIRECTORY weights)
message("DARKNET: Please download weights http://pjreddie.com/media/files/${network_name}.weights") #download_weights(yolo)
# download_weights(tiny-yolo-voc)
# download_weights(yolo-voc)

### INSTALL ###
install(DIRECTORY weights data cfg
  DESTINATION share/darknet
  USE_SOURCE_PERMISSIONS)
install(DIRECTORY src/
  DESTINATION include/darknet
  FILES_MATCHING PATTERN "*.h")
install(TARGETS darknet DESTINATION bin)
install(TARGETS dnl     DESTINATION lib)


### TEST ###
# if(CATKIN_ENABLE_TESTING)
#   find_package(rostest REQUIRED)
#   catkin_add_nosetests(test)
# endif()

=== cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(darknet C CXX)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -falign-functions=4") # for ROS?

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -std=c++0x")
else()
        message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support.")
endif()


## Compiler settings
if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--export-dynamic -Wall -Wno-sign-compare -fPIC")
endif()

#thread
FIND_PACKAGE(Threads)
list(APPEND LIBRARIES ${CMAKE_THREAD_LIBS_INIT})

# CUDA
FIND_PACKAGE(CUDA)
if (CUDA_FOUND)
    message(STATUS "CUDA Version: " ${CUDA_VERSION})
    message(STATUS "CUDA Libararies: " ${CUDA_LIBRARIES})
    include_directories(SYSTEM ${CUDA_INCLUDE_DIRS})
    list(APPEND LIBRARIES ${CUDA_LIBRARIES} ${CUDA_CUBLAS_LIBRARIES} ${CUDA_curand_LIBRARY} ${CUDA_cusparse_LIBRARY})
    list(APPEND CUDA_NVCC_FLAGS "-arch=sm_35;-O2;-Xcompiler;-fPIC;")
    set(CUDA_PROPAGATE_HOST_FLAGS OFF)
    add_definitions(-DGPU)
    cuda_include_directories(src)
else()
    list(APPEND LIBRARIES "m")
endif()

#BOOST
FIND_PACKAGE(Boost REQUIRED python)
FIND_PACKAGE(PythonLibs REQUIRED)
FIND_PACKAGE(OpenCV)

if(OpenCV_FOUND)
    add_definitions(-DOPENCV)
endif()

include_directories(SYSTEM ${Boost_INCLUDE_DIR})
include_directories(SYSTEM ${PYTHON_INCLUDE_DIR})
include_directories(SYSTEM ${OpenCV_INCLUDE_DIR})

include_directories(src)
set(SRC_DIR src)

FILE(GLOB SRC_FILES ${PROJECT_SOURCE_DIR}/${SRC_DIR}/*.c)
LIST(REMOVE_ITEM SRC_FILES "${PROJECT_SOURCE_DIR}/src/server.c")
LIST(REMOVE_ITEM SRC_FILES "${PROJECT_SOURCE_DIR}/src/old.c")
LIST(REMOVE_ITEM SRC_FILES "${PROJECT_SOURCE_DIR}/src/cpu_gemm.c")
#LIST(REMOVE_ITEM SRC_FILES "${PROJECT_SOURCE_DIR}/src/darknet.c")

if (CUDA_FOUND)

FILE(GLOB CU_SRC_FILES ${PROJECT_SOURCE_DIR}/${SRC_DIR}/*.cu)
LIST(REMOVE_ITEM CU_SRC_FILES "${PROJECT_SOURCE_DIR}/src/yolo_kernels.cu")
    
CUDA_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/src)

if(${CUDA_VERSION} VERSION_EQUAL "8.0" OR ${CUDA_VERSION} VERSION_GREATER "8.0")
  set(CUDA_ARCH_BIN "20 30 32 35 37 50 52" CACHE STRING "Specify 'real' GPU arch to build binaries for, BIN(PTX) format is supported. Example: 1.3 2.1(1.3) or 13 21(13)")
else() ## nvcc from nvidia-cuda-toolkit (14.04)
  set(CUDA_ARCH_BIN "20 30 35" CACHE STRING "Specify 'real' GPU arch to build binaries for, BIN(PTX) format is supported. Example: 1.3 2.1(1.3) or 13 21(13)")
  list(REMOVE_ITEM CUDA_NVCC_FLAGS " -std=c++11" " -std=c++0x")
endif()
set(CUDA_ARCH_PTX "" CACHE STRING "Specify 'virtual' PTX arch to build PTX intermediate code for. Example: 1.0 1.2 or 10 12")              

include(CudaComputeTargetFlags)
APPEND_TARGET_ARCH_FLAGS()

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS}  "-Xcompiler;-fPIC;")           
set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} "--ftz=true;--prec-div=false;--prec-sqrt=false") 

CUDA_COMPILE(cuda_objs ${CU_SRC_FILES})

    
message(STATUS "CUDA FOUND")
endif()


add_library(dnl SHARED ${SRC_FILES} ${CU_SRC_FILES} ${cuda_objs})
target_link_libraries(dnl ${LIBRARIES} ${OpenCV_LIBS})
add_executable(darknet ${SRC_DIR}/darknet.c)
target_link_libraries(darknet ${LIBRARIES} dnl)

=== debian/changelog ===
ros-indigo-darknet (2016.11.27-2trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Yuki Furuta <furushchev@jsk.imi.i.u-tokyo.ac.jp>  Wed, 01 Feb 2017 10:26:45 -0000

=== debian/control ===
Source: ros-indigo-darknet
Section: misc
Priority: extra
Maintainer: Yuki Furuta <furushchev@jsk.imi.i.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, nvidia-cuda-dev, nvidia-cuda-toolkit, ros-indigo-catkin, ros-indigo-rospy, ros-indigo-rostest
Homepage: http://pjreddie.com/darknet/
Standards-Version: 3.9.2

Package: ros-indigo-darknet
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, nvidia-cuda-toolkit
Description: Darknet is an open source neural network framework written in C and CUDA.
 It is fast, easy to install, and supports CPU and GPU computation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-darknet//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
